VSTGUI: UTF8String Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Public Types | Public Member Functions | List of all members
UTF8String Class Reference

holds an UTF8 encoded string and a platform representation of it More...

`#include <cstring.h>`

## Public Types
using | StringType = std::string
using | SizeType = StringType::size_type
using | CodePointIterator = UTF8CodePointIterator< StringType::const_iterator >

## Public Member Functions
| UTF8String (UTF8StringPtr str=nullptr)
| UTF8String (const UTF8String &other)
| UTF8String (const StringType &str)
| UTF8String (UTF8String &&other) noexcept
| UTF8String (StringType &&str) noexcept
UTF8String & | operator= (const UTF8String &other)
UTF8String & | operator= (const StringType &other)
UTF8String & | operator= (UTF8String &&other) noexcept
UTF8String & | operator= (StringType &&str) noexcept
UTF8String & | operator= (UTF8StringPtr str)
SizeType | length () const noexcept
bool | empty () const noexcept
void | copy (UTF8StringBuffer dst, SizeType dstSize) const noexcept
CodePointIterator | begin () const noexcept
CodePointIterator | end () const noexcept
bool | operator== (UTF8StringPtr str) const noexcept
bool | operator!= (UTF8StringPtr str) const noexcept
bool | operator== (const UTF8String &str) const noexcept
bool | operator!= (const UTF8String &str) const noexcept
bool | operator== (const StringType &str) const noexcept
bool | operator!= (const StringType &str) const noexcept
UTF8String & | operator+= (const UTF8String &other)
UTF8String & | operator+= (StringType::value_type ch)
UTF8String & | operator+= (const StringType::value_type *other)
UTF8String | operator+ (const UTF8String &other)
UTF8String | operator+ (StringType::value_type ch)
UTF8String | operator+ (const StringType::value_type *other)
void | assign (UTF8StringPtr str)
void | clear () noexcept
UTF8StringPtr | data () const noexcept
| operator const UTF8StringPtr () const noexcept
const StringType & | getString () const noexcept
IPlatformString * | getPlatformString () const noexcept
| operator bool () const =delete

## Detailed Description

holds an UTF8 encoded string and a platform representation of it

## Member Typedef Documentation

## ◆ CodePointIterator

using CodePointIterator = UTF8CodePointIterator<StringType::const_iterator>

## ◆ SizeType

using SizeType = StringType::size_type

## ◆ StringType

using StringType = std::string

## Constructor & Destructor Documentation

## ◆ UTF8String() [1/5]

UTF8String | ( | UTF8StringPtr | str = `nullptr` | ) |

## ◆ UTF8String() [2/5]

UTF8String | ( | const UTF8String & | other | ) |

## ◆ UTF8String() [3/5]

UTF8String | ( | const StringType & | str | ) |
| explicit

## ◆ UTF8String() [4/5]

UTF8String | ( | UTF8String && | other | ) |
| noexcept

## ◆ UTF8String() [5/5]

UTF8String | ( | StringType && | str | ) |
| noexcept

## Member Function Documentation

## ◆ assign()

void assign | ( | UTF8StringPtr | str | ) |

## ◆ begin()

UTF8String::CodePointIterator begin | ( |  | ) | const
| noexcept

## ◆ clear()

void clear | ( |  | ) |
| noexcept

## ◆ copy()

void copy | ( | UTF8StringBuffer | dst,
|  | SizeType | dstSize
| ) |  | const
| noexcept

## ◆ data()

UTF8StringPtr data | ( |  | ) | const
| inlinenoexcept

## ◆ empty()

bool empty | ( |  | ) | const
| inlinenoexcept

## ◆ end()

UTF8String::CodePointIterator end | ( |  | ) | const
| noexcept

## ◆ getPlatformString()

IPlatformString * getPlatformString | ( |  | ) | const
| noexcept

## ◆ getString()

const StringType & getString | ( |  | ) | const
| inlinenoexcept

## ◆ length()

SizeType length | ( |  | ) | const
| inlinenoexcept

## ◆ operator bool()

operator bool | ( |  | ) | const
| explicitdelete

## ◆ operator const UTF8StringPtr()

operator const UTF8StringPtr | ( |  | ) | const
| inlinenoexcept

## ◆ operator!=() [1/3]

bool operator!= | ( | const StringType & | str | ) | const
| noexcept

## ◆ operator!=() [2/3]

bool operator!= | ( | const UTF8String & | str | ) | const
| noexcept

## ◆ operator!=() [3/3]

bool operator!= | ( | UTF8StringPtr | str | ) | const
| noexcept

## ◆ operator+() [1/3]

UTF8String operator+ | ( | const StringType::value_type * | other | ) |

## ◆ operator+() [2/3]

UTF8String operator+ | ( | const UTF8String & | other | ) |

## ◆ operator+() [3/3]

UTF8String operator+ | ( | StringType::value_type | ch | ) |

## ◆ operator+=() [1/3]

UTF8String & operator+= | ( | const StringType::value_type * | other | ) |

## ◆ operator+=() [2/3]

UTF8String & operator+= | ( | const UTF8String & | other | ) |

## ◆ operator+=() [3/3]

UTF8String & operator+= | ( | StringType::value_type | ch | ) |

## ◆ operator=() [1/5]

UTF8String & operator= | ( | const StringType & | other | ) |

## ◆ operator=() [2/5]

UTF8String & operator= | ( | const UTF8String & | other | ) |

## ◆ operator=() [3/5]

UTF8String & operator= | ( | StringType && | str | ) |
| noexcept

## ◆ operator=() [4/5]

UTF8String & operator= | ( | UTF8String && | other | ) |
| noexcept

## ◆ operator=() [5/5]

UTF8String & operator= | ( | UTF8StringPtr | str | ) |
| inline

## ◆ operator==() [1/3]

bool operator== | ( | const StringType & | str | ) | const
| noexcept

## ◆ operator==() [2/3]

bool operator== | ( | const UTF8String & | str | ) | const
| noexcept

## ◆ operator==() [3/3]

bool operator== | ( | UTF8StringPtr | str | ) | const
| noexcept

The documentation for this class was generated from the following files:

- cstring.h
- cstring.cpp